/* UNTGZ Decompression Utiliy 0.94 Copyright (c) 1996 Tillmann Steinbrecher  

   This freeware program may be distributed according to the terms of the
   GNU general public license version 2 - see file 'copying' for details.

   Revision History
	Ver. 0.01	Sep  17, 1996	original version based on
					UNTGZ 0.94
 
 If you improve this code, please send it to:
                        steinbr@bigfoot.com
                        (note new e-mail adress)

 Known bugs:
     - none in this release.
       Please report any bugs you can find.

 To Do:
     - whatever YOU suggest
*/


#include <stdio.h>
#include <ctype.h>
#include <conio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string.h>
#include <errno.h>
#include <io.h>
#include <dos.h>
#include <process.h>

#ifdef __BORLANDC__
  #include <alloc.h>
  #include <dir.h>
  #include <time.h>
#endif

struct
{
  char MZ[2];
  int load_size;
  int load_page;
} exe_header;


#include    "tgzsfx.h"

#include    "inflate.c"
#include "crc_eng.c"
#include "dos_path.c"
#include "tar_eng.c"
#include "gzip_eng.c"

char aname[128];

int cdecl
main(int argc,char **argv){
	int i;
	int stat;
        long size;
        command=CMD_EXTRACT;
	printf("\n" LONG_NAME VERSION TEST_STATUS "\n"
		"Copyright (c) 1996 Tillmann Steinbrecher. "BUILD_DATE"\n\n");

#ifndef _32BIT_VERSION_
	ctrlbrk(c_break);
#endif
	if(argc>1) printf(PROG_NAME ": warning - ignoring command line argument\n");
	in=fopen(argv[0],"rb");
        fread(&exe_header,sizeof(exe_header),1,in);
	size=exe_header.load_page*512-512+exe_header.load_size;
	fseek(in,size,SEEK_SET);

	stat=read_gzip_header();
	if(stat) {
		fseek(in,size,SEEK_SET);
		stat=read_pkzip_header();
		}
	if(stat) {
		printf(PROG_NAME ": error - no valid compressed data following sfx code.\n");
		return -1;
                  }
	      else{
                if((outbuf=(byte*)malloc(OUTBUFSIZ))==0){
                        printf(PROG_NAME": error - can't allocate memory for write buffer");
                        return -1;
                        }
                                                          
                outptr=outbuf;

                if(inflate_entry()) printf(PROG_NAME ": decompression engine error - bad compressed data.\n");
		FlushOutput();
		check_valid();
		return 0;
		}

	}
