/* Definitions for UNTGZ - Copyright (c) 1996 Tillmann Steinbrecher */

#define	CMD_DONOTHING	0
#define	CMD_EXTRACT	1
#define CMD_EXTRACT_NOPATH	2
#define	CMD_LIST	3
#define	CMD_TEST	4
#define CMD_UNPACK	5

#define HEADER_GZIP 1
#define HEADER_PKZIP 2
#define HEADER_PKZIP_END 3

#ifdef _OS2_VERSION_
#define _32BIT_VERSION_
  #define LONG_NAME "TGZ solidSFX OS/2 self extractor version "
  #define PROG_NAME "\ntgzsfx"
#elif	defined( _32BIT_VERSION_ )
  #define LONG_NAME "TGZ solidSFX 32bit self extractor version "
  #define PROG_NAME "\ntgzsfx32"
#else
  #define PROG_NAME "\ntgzsfx"
  #define LONG_NAME "TGZ solidSFX self extractor version "
#endif

#define VERSION		"0.1 "
#define BUILD_DATE "Sep 17 1996"
#define TEST_STATUS	"(public beta)" /* or "beta ", "alpha ", " " */

#define TIME_BUG_WORKAROUND

#define UNC_OUTBUFSIZ 8192

char filespec[100];
int command=0;
int error=0;
char ignore_case=1;

int match(char*, char*, int);
